
#include <p18f2520.h>
#include <stdlib.h>
#include <delays.h>
#include <stdio.h>
#include <timers.h>

#pragma config OSC = INTIO67	//Internal oscillator block, CLKO function on RA6, port function on RA7  
#pragma config FCMEN = OFF	//Fail-Safe Clock Monitor Enable bit
#pragma config IESO = OFF	//Internal/External Oscillator Switchover bit
#pragma config PWRT = OFF	//PWRT enabled
#pragma config BOREN = OFF	//Brown-out Reset disabled in hardware and software 
#pragma config BORV = 0		//Maximum setting 
#pragma config WDT = OFF	//WDT disabled (control is placed on the SWDTEN bit) 
#pragma config WDTPS = 32768  //1:32768 
#pragma config CCP2MX = PORTC //CCP2 input/output is multiplexed with RC1 
#pragma config PBADEN = OFF	  //PORTB<4:0> pins are configured as digital I/O on Reset 
#pragma config LPT1OSC = OFF  //Timer1 configured for higher power operation
#pragma config MCLRE = ON	  //MCLR pin enabled; RE3 input pin disabled 
#pragma config STVREN = OFF	//Stack full/underflow will not cause Reset 
#pragma config LVP = OFF	//Single-Supply ICSP disabled
#pragma config XINST = OFF	//Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
//#pragma config DEBUG = ON	//Background debugger enabled, RB6 and RB7 are dedicated to In-Circuit Debug 
#pragma config CP0 = OFF	//Code Protection bit
#pragma config CP1 = OFF
#pragma config CP2 = OFF
#pragma config CP3 = OFF
#pragma config CPB = OFF
#pragma config CPD = OFF
#pragma config WRT0 = OFF	//Write Protection bit
#pragma config WRT1 = OFF
#pragma config WRT2 = OFF
#pragma config WRT3 = OFF
#pragma config WRTC = OFF	//Configuration Register Write Protection bit
#pragma config WRTB = OFF	//Boot Block Write Protection bit
#pragma config WRTD = OFF	//Data EEPROM Write Protection bit
#pragma config EBTR0 = OFF	//Table Read Protection bit
#pragma config EBTR1 = OFF
#pragma config EBTR2 = OFF
#pragma config EBTR3 = OFF
#pragma config EBTRB = OFF	//Boot Block Table Read Protection bit

unsigned char BCD, b, c, d, neg, D, HLED, count;
int k, DISPLAY;

rom near unsigned char HLs[] = // 7- 
{

	0xFC,		// 0	  
	0x60,		// 1    x g f e d c b a
	0xDA,		// 2
	0xF2,		// 3
	0x66,		// 4
	0xB6,		// 5
	0xBE,		// 6
	0xE0,		// 7
	0xFE,		// 8
	0xF6		// 9*/

/*	0x03,		// 0	    74HC595
	0x9F,		// 1
	0x25,		// 2
	0x0D,		// 3
	0x99,		// 4
	0x49,		// 5
	0x41,		// 6
	0x1F,		// 7
	0x01,		// 8
	0x09		// 9*/

/*	0xC0,		// 0	    74HC595
	0x60,		// 1
	0xDA,		// 2
	0xF2,		// 3
	0x66,		// 4
	0xB6,		// 5
	0xBE,		// 6
	0xE0,		// 7
	0xFE,		// 8
	0xF6		// 9*/
};

void BIN_TO_BCD (void)	// BIN  BCD ()
{	k = DISPLAY;
	b=0;
	c=0;
	d=0;
LATA = 0xFF;
	{	while (k>=100)
		{	k =(k-100);
			b++;}
		while (k>=10)
		{	k =(k-10);
			c++;}
		d = k;
	}

LATA = 0xFF;
	{
		b =(DISPLAY-DISPLAY%100)/100;	// 
		c =(DISPLAY%100-DISPLAY%10)/10;	// 
		d = DISPLAY%10;					// 
	}
return;
}


void main (void)
{
	ADCON1 = 0x0F;			//  
	CMCON = 0x07;			//  

	T0CONbits.TMR0ON = 0;
	T0CONbits.T0CS = 0;
	OSCCONbits.IRCF2 = 1;	// INTRC  111 - 8 / 000 - 32kHz
	OSCCONbits.IRCF1 = 0;
	OSCCONbits.IRCF0 = 0;
	OSCCONbits.SCS1 = 0;
	OSCCONbits.SCS0 = 0;
	OSCTUNEbits.PLLEN = 1;	//  4xPLL
	OSCTUNEbits.INTSRC = 1;	//   TMR  INTRC 8 

	TRISA = 0x00;    	// PORTA  
	LATA = 0xFF;		// LATA  
	PORTA = 0xFF;		// PORTA  

	TRISB = 0x00;    	// PORTB  
	LATB = 0x00;		// LATB  
	PORTB = 0x00;		// PORTB  

	TRISC = 0x00;    	// PORTC  
	LATC = 0x00;		// LATC  
	PORTC = 0x00;		// PORTC  

	neg = 0;		//  
	DISPLAY = 999;	//   
	D = 80;			//   
	HLED = 0;
	count = 1;		// 

while (1)
{
	BIN_TO_BCD();
	HLED = 0;
	while (HLED < 1)
	{
		HLED = 1;
		LATA = 0xFF;		//  
		LATC = HLs[d];
		LATA = 0x07;
		Delay10TCYx (D);
	
		LATA = 0xFF;		//  
		LATC = HLs[c]+1;	//   
		LATA = 0x0B;
		Delay10TCYx (D);
	
		LATA = 0xFF;		//  
			if (b == 0)
			{LATC = 0x00;}	//  -  "0"  
			else {
		LATC = HLs[b];}
		LATA = 0x0D;
		Delay10TCYx (D);
	
		LATA = 0xFF;
		if (neg == 1)
		{LATC = 0x02;} 		//  0x02    (0xFD)
		else {LATC = 0x00;}
		LATA = 0x0E;
		HLED++;
		Delay10TCYx (D);
	}

}
}
